'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utilsBootstrapUtils = require('./utils/bootstrapUtils');

var _utilsBootstrapUtils2 = _interopRequireDefault(_utilsBootstrapUtils);

var _reactPropTypesLibAll = require('react-prop-types/lib/all');

var _reactPropTypesLibAll2 = _interopRequireDefault(_reactPropTypesLibAll);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var ButtonGroup = (function (_React$Component) {
  _inherits(ButtonGroup, _React$Component);

  function ButtonGroup() {
    _classCallCheck(this, ButtonGroup);

    _React$Component.apply(this, arguments);
  }

  ButtonGroup.prototype.render = function render() {
    var classes = _utilsBootstrapUtils2['default'].getClassSet(this.props);

    classes[_utilsBootstrapUtils2['default'].prefix(this.props)] = !this.props.vertical;
    classes[_utilsBootstrapUtils2['default'].prefix(this.props, 'vertical')] = this.props.vertical;
    classes[_utilsBootstrapUtils2['default'].prefix(this.props, 'justified')] = this.props.justified;

    // this is annoying, since the class is `btn-block` not `btn-group-block`
    classes[_utilsBootstrapUtils2['default'].prefix(_Button2['default'].defaultProps, 'block')] = this.props.block;

    var _props = this.props;
    var dropup = _props.dropup;
    var pullRight = _props.pullRight;
    var bsSize = _props.bsSize;
    var bsStyle = _props.bsStyle;
    var componentClass = _props.componentClass;
    var block = _props.block;
    var justified = _props.justified;
    var vertical = _props.vertical;
    var bsClass = _props.bsClass;

    var otherProps = _objectWithoutProperties(_props, ['dropup', 'pullRight', 'bsSize', 'bsStyle', 'componentClass', 'block', 'justified', 'vertical', 'bsClass']);

    return _react2['default'].createElement(
      'div',
      _extends({}, otherProps, {
        className: _classnames2['default'](this.props.className, classes) }),
      this.props.children
    );
  };

  _createClass(ButtonGroup, null, [{
    key: 'propTypes',
    value: {
      vertical: _propTypes2['default'].bool,
      justified: _propTypes2['default'].bool
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    /**
     * Display block buttons, only useful when used with the "vertical" prop.
     * @type {bool}
     */
    // block: all(
    //   React.PropTypes.bool,
    //   props => {
    //     if (props.block && !props.vertical) {
    //       return new Error('The block property requires the vertical property to be set to have any effect');
    //     }
    //   }
    // )
    value: {
      block: false,
      justified: false,
      vertical: false
    },
    enumerable: true
  }]);

  return ButtonGroup;
})(_react2['default'].Component);

exports['default'] = _utilsBootstrapUtils.bsClass('btn-group', ButtonGroup);
module.exports = exports['default'];