'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;
exports.getTotalPages = getTotalPages;
exports.getActivePage = getActivePage;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Pagination = require('./Pagination');

var _Pagination2 = _interopRequireDefault(_Pagination);

function getTotalPages(props) {
	var pageSize = props.pageSize;
	var total = props.total;

	return Math.ceil(total / pageSize);
}

function getActivePage(props) {
	var activePage = props.activePage;

	var pageTotals = getTotalPages(props);
	return activePage < 1 ? 1 : activePage > pageTotals ? pageTotals : activePage;
}

var DataTablePagination = (function (_React$Component) {
	_inherits(DataTablePagination, _React$Component);

	function DataTablePagination() {
		_classCallCheck(this, DataTablePagination);

		_React$Component.apply(this, arguments);
	}

	DataTablePagination.prototype.render = function render() {
		var _props = this.props;
		var ellipsis = _props.ellipsis;
		var boundaryLinks = _props.boundaryLinks;
		var maxButtons = _props.maxButtons;
		var showTotalText = _props.showTotalText;
		var align = _props.align;
		var onChangePage = _props.onChangePage;
		var className = _props.className;

		var otherProps = _objectWithoutProperties(_props, ['ellipsis', 'boundaryLinks', 'maxButtons', 'showTotalText', 'align', 'onChangePage', 'className']);

		var totalPages = getTotalPages(otherProps);

		return totalPages > 1 ? _react2['default'].createElement(
			'div',
			_extends({}, otherProps, {
				className: _classnames2['default']('pagination-wapper', className) }),
			showTotalText ? _react2['default'].createElement(
				'span',
				{ className: 'total-text' },
				'共' + totalPages + '页 / ' + otherProps.total + '条'
			) : null,
			_react2['default'].createElement(_Pagination2['default'], {
				first: true,
				last: true,
				prev: true,
				next: true,
				ellipsis: ellipsis,
				boundaryLinks: boundaryLinks,
				maxButtons: maxButtons,
				items: totalPages,
				activePage: getActivePage(otherProps),
				onSelect: this.props.onChangePage })
		) : null;
	};

	_createClass(DataTablePagination, null, [{
		key: 'displayName',
		value: 'PaginationWapper',
		enumerable: true
	}]);

	return DataTablePagination;
})(_react2['default'].Component);

DataTablePagination.propTypes = {
	/**
  * 是否显示省略号按钮
  */
	ellipsis: _propTypes2['default'].bool,
	/**
  * 当ellipsis=true && boundaryLinks=true时，显示“第一页”、“最后一页”按钮
  * @type {[type]}
  */
	boundaryLinks: _propTypes2['default'].bool,
	/**
  * 最多显示的分页按钮数
  */
	maxButtons: _propTypes2['default'].number,
	/**
  * 当前页
  */
	activePage: _propTypes2['default'].number,
	/**
  * 分页大小
  */
	pageSize: _propTypes2['default'].number,
	/**
  * 数据总数
  */
	total: _propTypes2['default'].number,
	/**
  * 是否显示数据总数
  */
	showTotalText: _propTypes2['default'].bool,
	/**
  * 分页按钮的对齐方式，right or left
  */
	align: _propTypes2['default'].oneOf(['right', 'left']),
	/**
  * 点击分页按钮时的回调事件
  */
	onChangePage: _propTypes2['default'].func
};

DataTablePagination.defaultProps = {
	ellipsis: true,
	boundaryLinks: false,
	maxButtons: 5,
	activePage: 1,
	pageSize: 10,
	total: 0,
	showTotalText: false,
	align: 'right'
};

exports['default'] = DataTablePagination;