'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _utilsBootstrapUtils = require('./utils/bootstrapUtils');

var _utilsBootstrapUtils2 = _interopRequireDefault(_utilsBootstrapUtils);

var _Modal = require('./Modal');

var _Modal2 = _interopRequireDefault(_Modal);

var Dialog = (function (_React$Component) {
  _inherits(Dialog, _React$Component);

  function Dialog() {
    _classCallCheck(this, Dialog);

    _React$Component.apply(this, arguments);
  }

  Dialog.prototype.render = function render() {
    return _react2['default'].createElement(
      _Modal2['default'],
      _extends({}, this.props, {
        className: _classnames2['default'](this.props.className, _utilsBootstrapUtils2['default'].prefix(this.props, 'Modal')) }),
      this.props.children
    );
  };

  return Dialog;
})(_react2['default'].Component);

Dialog.propTypes = {
  /**
   * @private 
   * 是否居中，dialog 默认为垂直居中
   */
  autoFocus: _propTypes2['default'].bool,

  enforceFocus: _propTypes2['default'].bool,

  site: _propTypes2['default'].oneOf(['default', 'center']),
  /**
   * size 
   * 弹窗大小
   */
  size: _propTypes2['default'].object
};

Dialog.defaultProps = {
  autoFocus: false, // autoFocus + enforceFocus 如果2者有一为true, 弹窗内无法获取焦点，对弹窗内输入框
  enforceFocus: false,
  site: 'center'
};

Dialog.Header = _Modal2['default'].Header;
Dialog.Body = _Modal2['default'].Body;
Dialog.Title = _Modal2['default'].Title;
Dialog.Footer = _Modal2['default'].Footer;

exports['default'] = _utilsBootstrapUtils.bsClass('dialog', Dialog);
module.exports = exports['default'];