'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utilsCreateChainedFunction = require('./utils/createChainedFunction');

var _utilsCreateChainedFunction2 = _interopRequireDefault(_utilsCreateChainedFunction);

/**
 * Note: This is intended as a stop-gap for accessibility concerns that the
 * Bootstrap CSS does not address as they have styled anchors and not buttons
 * in many cases.
 */

var SafeAnchor = (function (_React$Component) {
  _inherits(SafeAnchor, _React$Component);

  function SafeAnchor() {
    var _this = this;

    _classCallCheck(this, SafeAnchor);

    _React$Component.apply(this, arguments);

    this.handleClick = function (event) {
      if (_this.props.href === undefined) {
        event.preventDefault();
      }
    };
  }

  SafeAnchor.prototype.render = function render() {
    var _props = this.props;
    var eventKey = _props.eventKey;
    var divider = _props.divider;
    var header = _props.header;
    var bsClass = _props.bsClass;

    var otherProps = _objectWithoutProperties(_props, ['eventKey', 'divider', 'header', 'bsClass']);

    return _react2['default'].createElement('a', _extends({ role: this.props.href ? undefined : 'button'
    }, otherProps, {
      onClick: _utilsCreateChainedFunction2['default'](this.props.onClick, this.handleClick),
      href: this.props.href || '' }));
  };

  return SafeAnchor;
})(_react2['default'].Component);

exports['default'] = SafeAnchor;

SafeAnchor.propTypes = {
  href: _propTypes2['default'].string,
  onClick: _propTypes2['default'].func
};
module.exports = exports['default'];