'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _Object$is = require('babel-runtime/core-js/object/is')['default'];

var _Object$assign = require('babel-runtime/core-js/object/assign')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _OptionJs = require('./Option.js');

var _OptionJs2 = _interopRequireDefault(_OptionJs);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Tooltip = require('./Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

var _Overlay = require('./Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var Select = (function (_React$Component) {
  _inherits(Select, _React$Component);

  function Select(props) {
    var _this = this;

    _classCallCheck(this, Select);

    _React$Component.call(this, props);

    this.isSelectAll = function () {
      return _this.state.data.length === _this.state.selectedData.length;
    };

    this.getDatas = function () {
      return _this.state.data;
    };

    this.getSelected = function () {
      return _this.state.selectedData;
    };

    this.getSelectedValue = function () {
      var value = [];
      _this.state.selectedData.forEach(function (item) {
        return value.push(item.value);
      });
      return value;
    };

    this.getSelectedText = function () {
      var text = [];
      _this.state.selectedData.forEach(function (item) {
        return text.push(item.text);
      });
      return text;
    };

    this.loadData = [];
    this.state = {
      focus: -1,
      open: props.open,
      outMaxSelect: false,
      data: [],
      selected: [],
      selectedData: [],
      isSelectAll: false
    };
  }

  Select.prototype.componentWillMount = function componentWillMount() {
    this.initSelect(this.props);
  };

  Select.prototype.componentDidMount = function componentDidMount() {
    window.removeEventListener('click', this.globalMouseClick.bind(this), false);
    window.addEventListener('click', this.globalMouseClick.bind(this), false);
    this.myselect.getElementsByClassName('myselect-body-scroll').scrollTop = 0;
  };

  Select.prototype.componentWillUnmount = function componentWillUnmount() {
    window.removeEventListener('click', this.globalMouseClick.bind(this));
  };

  Select.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps, nextState) {
    // 属性的改变目前只能引起 数值上的变化。
    var bool_value = false,
        bool_selected = false,
        tempValue = [];

    var _state = this.state;
    var selectedData = _state.selectedData;
    var selected = _state.selected;

    selectedData.forEach(function (item) {
      return tempValue.push(item.value);
    });

    var value = tempValue.length > 1 ? tempValue : tempValue[0];

    // value 相同的情况

    if (Array.isArray(value) && Array.isArray(nextProps.value)) {
      bool_value = !_Object$is(value.sort().toString(), nextProps.value.sort().toString());
    } else {
      bool_value = !_Object$is(value, nextProps.value);
    }

    // selected 相同的情况

    if (Array.isArray(selected) && Array.isArray(nextProps.selected)) {
      bool_selected = !_Object$is(selected.sort().toString(), nextProps.selected.sort().toString());
    } else {
      bool_selected = !_Object$is(selected, nextProps.selected);
    }

    (bool_value || bool_selected) && this.changeText(nextProps);

    // 当再次接受到children时，进行更新
    if (nextProps.children) {
      if (!this.props.children) {
        this.initSelect(nextProps);
      } else {
        // 如果长度不一致，
        var __thisProps = this.chilrenToArray(this.props),
            __nextProps = this.chilrenToArray(nextProps);
        if (__thisProps.length !== __nextProps.length) {
          this.initSelect(nextProps);
        } else {
          // 长度一致则进行更深层比较
          var __thisValues = this.valueOfOptions(__thisProps),
              __nextValues = this.valueOfOptions(__nextProps);
          _Object$is(__thisValues.sort().toString(), __nextValues.sort().toString()) || this.initSelect(nextProps);
        }
      }
    } else {
      this.initSelect(nextProps);
    }
  };

  Select.prototype.render = function render() {
    var _classNames,
        _this2 = this;

    var _props = this.props;
    var disabled = _props.disabled;
    var style = _props.style;
    var width = _props.width;
    var value = _props.value;
    var selected = _props.selected;
    var fixContainer = _props.fixContainer;

    var otherProps = _objectWithoutProperties(_props, ['disabled', 'style', 'width', 'value', 'selected', 'fixContainer']);

    var classes = _classnames2['default'](otherProps.className, (_classNames = {
      myselect: true
    }, _classNames[otherProps.type] = true, _classNames));

    // width 存在的情况下
    if (width) {
      if (style && style.width) {
        style.width = width;
      } else {
        style = _Object$assign({}, { width: width });
      }
    }

    return _react2['default'].createElement(
      'div',
      { style: style, ref: function (node) {
          _this2.myselect = node;
        }, className: classes },
      disabled ? this.renderDisabledHeader() : this.renderHeader(),
      fixContainer ? _react2['default'].createElement(
        _Overlay2['default'],
        {
          show: this.state.open,
          animation: false,
          onHide: function () {
            return _this2.setState({ open: false });
          },
          placement: 'bottom',
          container: fixContainer,
          target: function () {
            return _this2.myselect;
          }
        },
        this.renderBody(style.width)
      ) : _react2['default'].createElement(
        'div',
        { style: this.state.open && !disabled ? {} : { display: 'none' } },
        this.renderBody()
      )
    );
  };

  Select.prototype.renderDisabledHeader = function renderDisabledHeader() {
    var disabled = this.props.disabled;
    var text = this.state.text;

    return _react2['default'].createElement(
      'div',
      { className: _classnames2['default']('myselect-head', { disabled: disabled }) },
      _react2['default'].createElement(
        'div',
        { className: 'items' },
        text
      ),
      _react2['default'].createElement(
        'div',
        { className: 'dropdown-toggle' },
        _react2['default'].createElement('i', null)
      )
    );
  };

  Select.prototype.renderHeader = function renderHeader() {
    var _this3 = this;

    var _props2 = this.props;
    var type = _props2.type;
    var openSearch = _props2.openSearch;
    var showMultipleSize = _props2.showMultipleSize;
    var onClear = _props2.onClear;
    var tooltip = _props2.tooltip;
    var placeholder = _props2.placeholder;
    var text = this.state.text;

    var searchInput = function searchInput(noTitle) {
      return _react2['default'].createElement(
        'div',
        { className: 'multiple-input-wrap' },
        noTitle === false ? _react2['default'].createElement('input', {
          type: 'text',
          className: 'search-input',
          placeholder: placeholder,
          value: text,
          onClick: _this3.onHandClick.bind(_this3),
          onKeyDown: _this3.onEnterSearch.bind(_this3),
          onChange: _this3.onHandChange.bind(_this3)
        }) : _react2['default'].createElement('input', {
          type: 'text',
          className: 'search-input',
          placeholder: placeholder,
          value: text,
          title: text,
          onClick: _this3.onHandClick.bind(_this3),
          onKeyDown: _this3.onEnterSearch.bind(_this3),
          onChange: _this3.onHandChange.bind(_this3)
        }),
        !!onClear && text.length > 0 ? _react2['default'].createElement(
          'span',
          { className: 'Select-value-icon', onClick: _this3.unSelectAll.bind(_this3) },
          '×'
        ) : null
      );
    };
    var innerText = function innerText(noTitle) {
      switch (type) {
        case 'single':
          return searchInput(noTitle);
        case 'multiple':
          return (function () {
            if (openSearch) {
              var showText = text.length > 0 && showMultipleSize > -1 && text.length > showMultipleSize ? text.slice(0, showMultipleSize) + '...' : text;
              return _react2['default'].createElement(
                'div',
                { className: 'multiple-input-wrap' },
                noTitle === false ? _react2['default'].createElement('input', {
                  type: 'text',
                  placeholder: placeholder,
                  className: 'search-input',
                  value: showText,
                  onKeyDown: _this3.onEnterSearch.bind(_this3),
                  onClick: _this3.onHandClick.bind(_this3),
                  onChange: _this3.onHandChange.bind(_this3)
                }) : _react2['default'].createElement('input', {
                  type: 'text',
                  placeholder: placeholder,
                  className: 'search-input',
                  value: showText,
                  title: showText,
                  onKeyDown: _this3.onEnterSearch.bind(_this3),
                  onClick: _this3.onHandClick.bind(_this3),
                  onChange: _this3.onHandChange.bind(_this3)
                }),
                !!onClear && text.length > 0 ? _react2['default'].createElement(
                  'span',
                  { className: 'Select-value-icon', onClick: _this3.unSelectAll.bind(_this3) },
                  '×'
                ) : null
              );
            }
          })();
      }
    };

    var _tooltip = _react2['default'].createElement(
      _Tooltip2['default'],
      null,
      text
    );
    return _react2['default'].createElement(
      'div',
      { className: 'myselect-head', onClick: this.toggleMenu.bind(this) },
      _react2['default'].createElement(
        'div',
        { className: 'items', ref: function (node) {
            _this3.multipleItem = node;
          } },
        _react2['default'].createElement(
          'span',
          null,
          innerText()
        )
      ),
      _react2['default'].createElement(
        'div',
        { className: 'dropdown-toggle', onClick: this.handleToggleMenu.bind(this) },
        _react2['default'].createElement('i', null)
      )
    );
  };

  Select.prototype.renderBody = function renderBody(width) {
    var _this4 = this;

    var _props3 = this.props;
    var type = _props3.type;
    var openSearch = _props3.openSearch;
    var hasIcon = _props3.hasIcon;
    var maxSelectedSize = _props3.maxSelectedSize;
    var maxHeight = _props3.maxHeight;
    var noSearchDataTips = _props3.noSearchDataTips;
    var showMultipleBar = _props3.showMultipleBar;
    var tooltip = _props3.tooltip;
    var bottomBars = _props3.bottomBars;
    var fixContainer = _props3.fixContainer;
    var _state2 = this.state;
    var data = _state2.data;
    var selectedData = _state2.selectedData;
    var text = _state2.text;
    var selected = _state2.selected;
    var outMaxSelect = _state2.outMaxSelect;
    var focus = _state2.focus;
    var isSelectAll = _state2.isSelectAll;

    // 渲染主要区域
    var renderBodyMain = function renderBodyMain() {
      var unselectData = [],
          selecteds = [],
          text = [],
          newDatas = [];
      // 当为复选框，且开启搜索的时候
      if (type === 'multiple' && openSearch) {
        (function () {
          var datas = [].concat(data);
          var selects = [];
          selectedData.forEach(function (item, index) {
            _this4.contains(data, item) && selects.push(item);
          });

          selects.forEach(function (item, index) {
            newDatas.push(item);
            selecteds.push(index);
            text.push(item.text);
            datas = datas.filter(function (data) {
              return item.value !== data.value;
            });
          });

          unselectData = datas;
          unselectData.forEach(function (item) {
            return newDatas.push(item);
          });
          data = newDatas;
          text = text;
          selected = selecteds;
        })();
      }

      return data.map(function (item, i) {
        var isSelect = false;
        typeof selected === 'object' && selected.map(function (item) {
          return item === i && (isSelect = true);
        });
        return unselectData.length > 0 && selected.length !== 0 && i === selected.length ? _react2['default'].createElement(
          'div',
          { key: i },
          _react2['default'].createElement('hr', null),
          _react2['default'].createElement(_OptionJs2['default'], {
            focused: focus === i,
            item: item,
            selected: isSelect,
            index: i,
            hasIcon: hasIcon,
            type: type,
            tooltip: tooltip,
            selectItem: _this4.selectItem.bind(_this4, i)
          })
        ) : _react2['default'].createElement(_OptionJs2['default'], {
          key: i,
          focused: focus === i,
          item: item,
          selected: isSelect,
          index: i,
          hasIcon: hasIcon,
          type: type,
          tooltip: tooltip,
          selectItem: _this4.selectItem.bind(_this4, i)
        });
      });
    };

    var classes = isSelectAll ? 'checkbox-inner checked' : 'checkbox-inner';
    // 渲染操作栏目部分
    var renderBodyMG = function renderBodyMG() {
      return maxSelectedSize > -1 ? type === 'multiple' && data.length > 0 && _react2['default'].createElement(
        'div',
        { className: 'myselect-opration' },
        '最多可选择（',
        _react2['default'].createElement(
          'em',
          { className: outMaxSelect ? 'error' : '' },
          maxSelectedSize
        ),
        '）项'
      ) : showMultipleBar && type === 'multiple' && data.length > 0 && _react2['default'].createElement(
        'div',
        { className: 'myselect-opration' },
        _react2['default'].createElement(
          'div',
          { className: 'select-all-wrap', onClick: _this4.selectAll.bind(_this4) },
          _react2['default'].createElement('i', { className: classes }),
          _react2['default'].createElement(
            'span',
            null,
            '全选'
          )
        )
      );
    };
    var className = _classnames2['default']('myselect-body', {
      hasBottom: !!bottomBars,
      'fixed-select': fixContainer
    });

    var style = bottomBars ? { width: width, height: maxHeight + 40 } : { width: width, maxHeight: maxHeight };

    return _react2['default'].createElement(
      'div',
      {
        className: className,
        style: style,
        ref: function (node) {
          _this4.myselectBody = node;
        } },
      _react2['default'].createElement(
        'div',
        { className: _classnames2['default']({ bottomBars: !!bottomBars }), style: bottomBars ? { height: maxHeight - 7 } : null },
        _react2['default'].createElement(
          'div',
          { className: 'myselect-body-scroll' },
          data.length > 0 ? renderBodyMain() : _react2['default'].createElement(
            'div',
            { className: 'no-data' },
            _react2['default'].createElement(
              'div',
              { className: 'text' },
              noSearchDataTips
            )
          ),
          renderBodyMG()
        )
      ),
      !!bottomBars && _react2['default'].createElement(
        'div',
        { className: 'bottomBars-wrapper' },
        bottomBars
      )
    );
  };

  Select.prototype.valueOfOptions = function valueOfOptions(options) {
    var values = [];
    Array.isArray(options) && options.forEach(function (option) {
      values.push(option.props.value);
    });
    return values;
  };

  Select.prototype.chilrenToArray = function chilrenToArray(props) {
    var children = [];
    if (props.children instanceof Array) {
      props.children.map(function (item) {
        item instanceof Array ? children = children.concat(item) : children.push(item);
      });
    } else {
      children.push(props.children);
    }
    return children;
  };

  // 初始化 select 。给定初始值

  Select.prototype.initSelect = function initSelect(props) {
    var _this5 = this;

    var value = [],
        text = [],
        selected = [],
        focus = 0;
    this.loadData = [];
    // 遍历 props.children , 给定选中值
    props.children && this.chilrenToArray(props).forEach(function (item, index) {
      var option = {
        value: item.props.value,
        text: item.props.children
      };
      // 额外传递的参数
      if (item.props && !!item.props.data) {
        _Object$assign(option, _extends({}, item.props.data));
      }
      // 将每项option 存入 loaddata
      _this5.loadData.push(option);
      // 优先selectAll -> 匹配value  , -> 匹配selected
      if (props.type === 'multiple' && props.selectAll) {
        text.push(item.props.children);
        value.push(option);
        selected.push(index);
        focus = index;
      } else if (props.value !== undefined) {
        var values = props.value;
        if (typeof values === 'string' && values === item.props.value) {
          text.push(item.props.children);
          value.push(option);
          selected.push(index);
          focus = index;
        } else if (typeof values === 'object' && values.length > 0) {
          values.map(function (val) {
            if (val === item.props.value) {
              text.push(item.props.children);
              value.push(option);
              selected.push(index);
              focus = index;
            }
          });
        }
      } else if (props.selected !== undefined) {
        var selects = props.selected;
        if (typeof selects === 'number' && index === selects) {
          text.push(item.props.children);
          value.push(option);
          selected.push(index);
          focus = index;
        } else if (typeof selects === 'object' && selects.length > 0) {
          selects.map(function (select) {
            if (index === select) {
              text.push(item.props.children);
              value.push(option);
              selected.push(index);
              focus = index;
            }
          });
        }
      } else {
        // 默认选择第一项
        if (props.type === 'single' && props.selected === undefined) {
          text = [_this5.loadData[0].text];
          value = [_this5.loadData[0]];
          selected = [0];
          focus = 0;
        }
      }
    });

    this.setState({
      text: text,
      focus: focus,
      data: this.loadData,
      selected: selected,
      selectedData: value
    });
  };

  // 当select手动更改值。

  Select.prototype.changeText = function changeText(props) {
    var text = [],
        value = [],
        selected = [];
    this.loadData.forEach(function (option, index) {
      // 优先selectAll -> 匹配value  , -> 匹配selected
      if (props.type === 'multiple' && props.selectAll) {
        text.push(option.text);
        value.push(option);
        selected.push(index);
      } else if (props.value !== undefined) {
        var values = props.value;
        if (typeof values === 'string' && values === option.value) {
          text.push(option.text);
          value.push(option);
          selected.push(index);
        } else if (typeof values === 'object' && values.length > 0) {
          values.map(function (val) {
            if (val === option.value) {
              text.push(option.text);
              value.push(option);
              selected.push(index);
            }
          });
        }
      } else if (props.selected !== undefined) {
        var selects = props.selected;
        if (typeof selects === 'number' && index === selects) {
          text.push(option.text);
          value.push(option);
          selected.push(index);
        } else if (typeof selects === 'object' && selects.length > 0) {
          selects.map(function (select) {
            if (index === select) {
              text.push(option.text);
              value.push(option);
              selected.push(index);
            }
          });
        }
      }
    });
    this.setState({
      text: text,
      selected: selected,
      selectedData: value
    });
  };

  // 是否包含

  Select.prototype.contains = function contains(array, item) {
    var bool = false;
    array.forEach(function (arr) {
      if (arr.value === item.value) return bool = true;
    });
    return bool;
  };

  Select.prototype.onHandChange = function onHandChange(e) {
    e.stopPropagation();
    this.props.openSearch && this.filterBySearch();
  };

  Select.prototype.onEnterSearch = function onEnterSearch(e) {
    var _this6 = this;

    e.stopPropagation();
    if (e.keyCode === 13) {
      if (!!e.target.value && this.state.data.length > 0) {
        (function () {
          var _selectItem = _this6.state.data[0];
          switch (_this6.props.type) {
            case 'single':
              (function () {
                _this6.setState({
                  text: _selectItem ? _selectItem.text : '',
                  focus: -1,
                  selectedData: _selectItem ? [_selectItem] : []
                }, function () {
                  _this6.toggleMenu();
                  _this6.props.onSelected && _this6.props.onSelected(_selectItem);
                });
              })();break;
            case 'multiple':
              (function () {
                var _state3 = _this6.state;
                var selectedData = _state3.selectedData;
                var data = _state3.data;
                var outMaxSelect = _state3.outMaxSelect;
                var maxSelectedSize = _this6.props.maxSelectedSize;

                var itemIndex = _this6.hasItemIndex(_selectItem);
                var text = [],
                    selected = [];
                // 如果已经被选中
                if (itemIndex > -1) {
                  outMaxSelect = false;
                  selectedData.splice(itemIndex, 1);
                } else {
                  maxSelectedSize > -1 && selectedData.length === maxSelectedSize ? outMaxSelect = true : selectedData.push(_selectItem);
                }
                // 重新遍历data
                selectedData.forEach(function (select) {
                  _this6.loadData.forEach(function (option, index) {
                    option.value === select.value && text.push(select.text);
                  });
                });
                selectedData.forEach(function (select) {
                  data.forEach(function (option, index) {
                    option.value === select.value && selected.push(index);
                  });
                });
                _this6.setState({
                  text: text,
                  focus: -1,
                  outMaxSelect: outMaxSelect,
                  selected: selected,
                  selectedData: selectedData
                }, function () {
                  _this6.props.onSelected && _this6.props.onSelected(selectedData);
                });
              })();break;
          }
        })();
      } else {
        var _state4 = this.state;
        var _focus = _state4.focus;
        var selected = _state4.selected;
        var type = this.props.type;

        if (_focus > -1) {
          (function () {
            var select = _this6.state.data[_focus];
            switch (type) {
              case 'single':
                {
                  _this6.setState({
                    open: false,
                    text: select.text,
                    focus: _focus,
                    selected: [_focus],
                    selectedData: [select]
                  }, function () {
                    _this6.props.onSelected && _this6.props.onSelected(select);
                  });
                }break;
            }
          })();
        }
      }
    } else {
      this.handleKeyDownOption(e);
    }
  };

  Select.prototype.onHandClick = function onHandClick(e) {
    var _this7 = this;

    e.stopPropagation();
    // 组织冒泡导致不可关闭
    if (this.myselectBody) {
      this.myselectBody.click();
    }
    var selects = [];
    var _state5 = this.state;
    var open = _state5.open;
    var selected = _state5.selected;
    var text = _state5.text;
    var data = _state5.data;
    var selectedData = _state5.selectedData;

    // 重置序列
    if (selectedData && selectedData.length > 0) {
      selectedData.forEach(function (select) {
        _this7.loadData.map(function (item, index) {
          select.value === item.value && selects.push(index);
        });
      });
    }

    if (!open) {
      if (!this.props.openSearch) {
        open = true;
        data = this.loadData;
        selected = selects;
      } else {
        open = true;
        text = [];
        data = this.loadData;
        selected = selects;
      }
    } else if (this.props.openSearch && this.props.type === 'multiple') {
      open = true;
      text = [];
      data = this.loadData;
      selected = selects;
    }

    this.setState({
      open: open,
      text: text,
      selected: selected,
      data: data
    });
  };

  Select.prototype.filterBySearch = function filterBySearch() {
    var _this8 = this;

    var filter = this.myselect.getElementsByClassName('search-input')[0].value;
    var data = [],
        selected = [];

    this.loadData.forEach(function (item, index) {
      item.text.toString().toLowerCase().indexOf(filter.toLowerCase()) > -1 && data.push(item);
    });

    // 重新匹配是否有选中
    switch (this.props.type) {
      case 'single':
        (function () {
          data.map(function (item, index) {
            if (_this8.state.selectedData && _this8.state.selectedData.length > 0) {
              _this8.state.selectedData[0].value === item.value && selected.push(index);
            }
          });
        })();break;
      case 'multiple':
        (function (item, index) {
          data.map(function (item, index) {
            if (_this8.state.selectedData && _this8.state.selectedData.length > 0) {
              // 序列重置
              _this8.state.selectedData.forEach(function (select) {
                select.value === item.value && selected.push(index);
              });
            }
          });
        })();break;
    }

    this.setState({
      text: [filter],
      data: data,
      focus: -1,
      selected: selected
    });
  };

  Select.prototype.toggleMenu = function toggleMenu() {
    // 组织冒泡导致不可关闭
    if (this.myselectBody) {
      this.myselectBody.click();
    }

    this.setState({
      open: !this.state.open
    });
  };

  // 手动点击关闭

  Select.prototype.handleToggleMenu = function handleToggleMenu(e) {
    var _this9 = this;

    e.stopPropagation();
    if (this.myselectBody) {
      this.myselectBody.click();
    }
    var type = this.props.type;
    var _state6 = this.state;
    var selectedData = _state6.selectedData;
    var open = _state6.open;

    var texts = [];
    switch (type) {
      case 'single':
        (function () {
          if (selectedData && selectedData.length > 0) {
            texts.push(selectedData[0].text);
          }
        })();break;
      case 'multiple':
        (function () {
          if (selectedData && selectedData.length > 0) {
            // 序列重置
            selectedData.forEach(function (select) {
              _this9.loadData.map(function (item, index) {
                if (select.value === item.value) {
                  texts.push(select.text);
                }
              });
            });
          }
        })();break;
    }
    this.setState({
      open: !open,
      text: open === true ? texts : []
    }, function () {
      open === false && _this9.myselect.getElementsByClassName('search-input')[0].focus();
    });
  };

  Select.prototype.hasItemIndex = function hasItemIndex(item) {
    var index = -1;
    this.state.selectedData.forEach(function (select, i) {
      select.value === item.value && (index = i);
    });
    return index;
  };

  Select.prototype.selectItem = function selectItem(focusIndex, item) {
    var _this10 = this;

    var _props4 = this.props;
    var onSelected = _props4.onSelected;
    var maxSelectedSize = _props4.maxSelectedSize;

    // 失去焦点
    if (!item) {
      return false;
    }
    this.myselect.getElementsByClassName('search-input')[0].blur();
    switch (this.props.type) {
      case 'single':
        (function () {
          _this10.setState({
            text: item.text,
            focus: focusIndex,
            selectedData: [item]
          }, function () {
            _this10.toggleMenu();
            onSelected && onSelected(item);
          });
        })();break;
      case 'multiple':
        (function () {
          var _state7 = _this10.state;
          var selectedData = _state7.selectedData;
          var data = _state7.data;
          var outMaxSelect = _state7.outMaxSelect;

          var itemIndex = _this10.hasItemIndex(item);
          var text = [],
              selected = [];
          // 如果已经被选中
          if (itemIndex > -1) {
            outMaxSelect = false;
            selectedData.splice(itemIndex, 1);
          } else {
            maxSelectedSize > -1 && selectedData.length === maxSelectedSize ? outMaxSelect = true : selectedData.push(item);
          }
          // 重新遍历data
          selectedData.forEach(function (select) {
            _this10.loadData.forEach(function (option, index) {
              option.value === select.value && text.push(select.text);
            });
          });
          selectedData.forEach(function (select) {
            data.forEach(function (option, index) {
              option.value === select.value && selected.push(index);
            });
          });

          _this10.setState({
            text: text,
            focus: focusIndex,
            outMaxSelect: outMaxSelect,
            selected: selected,
            selectedData: selectedData,
            isSelectAll: data.length === selectedData.length
          }, function () {
            onSelected && onSelected(selectedData);
          });
        })();break;
    }
  };

  Select.prototype.handleKeyDownOption = function handleKeyDownOption(e) {
    var _state8 = this.state;
    var focus = _state8.focus;
    var data = _state8.data;

    switch (e.keyCode) {
      // ESC
      case 27:
        this.handleToggleMenu(e);break;
      // enter
      // case 13: focus > -1 && this.selectItem(focus,data[focus]); break;
      // up
      case 38:
        this.setState({
          focus: focus > 0 ? --focus : 0
        });this.controlScrolling();break;
      // down
      case 40:
        this.setState({
          focus: focus < data.length - 1 ? ++focus : data.length - 1
        });this.controlScrolling();break;
    }
  };

  Select.prototype.controlScrolling = function controlScrolling() {
    var _state9 = this.state;
    var focus = _state9.focus;
    var data = _state9.data;

    if (focus < 0 || focus >= data.length) {
      return false;
    }
    var mySelectBody = this.myselect.getElementsByClassName('myselect-body')[0];
    var focusedItem = this.myselect.getElementsByClassName('myselect-item')[focus];
    var specialClassElement = this.myselect.getElementsByClassName('myselect-body-scroll')[0];

    var paddingTop = parseInt(mySelectBody.style.paddingTop);
    var paddingBottom = parseInt(mySelectBody.style.paddingBottom);

    paddingTop = paddingTop > -1 ? paddingTop : 0;
    paddingBottom = paddingBottom > -1 ? paddingBottom : 0;

    var windowHeight = mySelectBody.clientHeight - paddingTop - paddingBottom;
    var elementHeight = focusedItem.clientHeight;
    var elementOffsetTop = focusedItem.offsetTop - paddingTop;
    var elementCountPerWindow = Math.floor(windowHeight / elementHeight);
    var scrollTop = specialClassElement.scrollTop;

    if (elementOffsetTop > windowHeight + scrollTop - elementHeight) {
      mySelectBody.scrollTop = elementOffsetTop - (elementCountPerWindow - 1) * elementHeight;
    } else if (elementOffsetTop < scrollTop) {
      mySelectBody.scrollTop = elementOffsetTop;
    } else if (focus === 0) {
      mySelectBody.scrollTop = 0;
    }
  };

  Select.prototype.removeItem = function removeItem(index, e) {
    var _this11 = this;

    e.stopPropagation();
    var _state10 = this.state;
    var selected = _state10.selected;
    var selectedData = _state10.selectedData;
    var texts = this.state.text;
    if (index || index === 0) {
      texts.splice(index, 1);
      selected.splice(index, 1);
      selectedData.splice(index, 1);
    }
    this.setState({
      text: texts,
      selected: selected,
      selectedData: selectedData
    }, function () {
      _this11.props.onSelected && _this11.props.onSelected(selectedData);
    });
  };

  Select.prototype.globalMouseClick = function globalMouseClick(event) {
    var _this12 = this;

    if (!this.myselect) {
      return;
    }
    var target = event.target || event.srcElement,
        inHead = this.closest(target, 'myselect-head'),
        inBody = this.closest(target, 'myselect-body');
    if (!inHead && !inBody) {
      (function () {
        var _state11 = _this12.state;
        var text = _state11.text;
        var data = _state11.data;
        var selected = _state11.selected;
        var open = _state11.open;
        var selectedData = _state11.selectedData;
        var selects = [];
        var texts = [];
        /* if (!this.props.openSearch) {
          return ;
        } */
        switch (_this12.props.type) {
          case 'single':
            (function () {
              if (selectedData && selectedData.length > 0) {
                texts.push(selectedData[0].text);
                // 序列重置
                _this12.loadData.map(function (item, index) {
                  if (selectedData[0].value === item.value) selects.push(index);
                });

                text = texts;
                data = _this12.loadData;
                selected = selects;
              } else {
                text = '';
                selected = [];
              }
            })();break;
          case 'multiple':
            (function () {
              if (selectedData && selectedData.length > 0) {
                // 序列重置
                selectedData.forEach(function (select) {
                  _this12.loadData.map(function (item, index) {
                    if (select.value === item.value) {
                      selects.push(index);
                      texts.push(select.text);
                    }
                  });
                });

                text = texts;
                data = _this12.loadData;
                selected = selects;
              } else {
                text = [];
                selected = [];
              }
            })();break;
        }

        _this12.setState({
          open: false,
          text: text,
          data: data,
          selected: selected
        });
      })();
    }
  };

  Select.prototype.closest = function closest(target, className) {
    if (target && (target.nodeName.toLowerCase() === 'body' || target.nodeName.toLowerCase() === 'svg' || typeof target.className === 'string' && target.className.indexOf(className) > -1)) {
      return false;
    } else if (!target) {
      return true;
    }
    return target.parentElement && target.parentElement.className && typeof target.parentElement.className === 'string' && target.parentElement.className.indexOf(className) > -1 ? true : this.closest(target.parentElement, className);
  };

  Select.prototype.selectAll = function selectAll(e) {
    e.stopPropagation();
    var text = [],
        selected = [];

    if (!this.isSelectAll()) {
      this.state.data.length > 0 && this.state.data.forEach(function (item, index) {
        text.push(item.text);
        selected.push(index);
      });

      this.setState({
        text: text,
        focus: -1,
        selected: selected,
        selectedData: JSON.parse(JSON.stringify(this.state.data)),
        isSelectAll: true
      });
    } else {
      this.setState({
        text: text,
        focus: -1,
        selected: selected,
        selectedData: [],
        isSelectAll: false
      });
    }
  };

  Select.prototype.unSelectAll = function unSelectAll(e) {
    var _this13 = this;

    e.stopPropagation();
    this.setState({
      text: [],
      focus: -1,
      selected: [],
      selectedData: []
    }, function () {
      // 如果没有此回调，在调用后的数据不清空，state 状态更新依旧会存在数据
      _this13.props.onClear && typeof _this13.props.onClear === 'function' && _this13.props.onClear();
    });
  };

  // isSelectAll 是否选中
  return Select;
})(_react2['default'].Component);

Select.propTypes = {
  /**
   * 最大高度，超过出现滚动条
   * {number}
   */
  maxHeight: _propTypes2['default'].number,
  /**
   * 宽度
   * {number|string}
   */
  width: _propTypes2['default'].oneOfType([_propTypes2['default'].string, _propTypes2['default'].number]),
  /**
   * 是否开启搜索
   * {boolean}
   */
  openSearch: _propTypes2['default'].bool,
  /**
   * select 类型 ， single -> 单选(默认)，multiple -> 复选
   * {[type]}
   */
  type: _propTypes2['default'].oneOf(['single', 'multiple']),
  /**
   * onSelect 选中事件
   */
  onSelected: _propTypes2['default'].func,
  /**
   * onClear 清除已选内容事件, 如果是通过OnSelected 去取值的话，清空后的数据，需要通过onClear去清楚
   */
  onClear: _propTypes2['default'].func,
  /**
   * 设置选中序列号
   * {number | array}
   */
  selected: _propTypes2['default'].oneOfType([_propTypes2['default'].array, _propTypes2['default'].number]),
  /**
   * 设置所选中的值
   * {string | array}
   */
  value: _propTypes2['default'].oneOfType([_propTypes2['default'].array, _propTypes2['default'].string]),
  /**
   * @private
   * 禁用
   */
  disabled: _propTypes2['default'].bool,
  /**
   * 是否显示图标
   * {Boolean}
   */
  hasIcon: _propTypes2['default'].bool,
  /**
   * 是否打开
   * {Boolean}
   */
  open: _propTypes2['default'].bool,
  /**
   * 是否选中全部
   * {boolean}
   */
  selectAll: _propTypes2['default'].bool,
  /**
   * 搜索开启，无查找内容提示语
   * {string}
   */
  noSearchDataTips: _propTypes2['default'].string,
  /**
   * 复选显示在输入框size
   * {number}
   */
  showMultipleSize: _propTypes2['default'].number,
  /**
   * 复选情况下是否显示 全选
   * @type {boolean}
   */
  showMultipleBar: _propTypes2['default'].bool,
  /**
   * 复选框最多选中的项数，配置此属性，则showMultipleBar失效
   * {number}
   */
  maxSelectedSize: _propTypes2['default'].number,
  /**
   * 选项提示信息
   * @type {Object}
   */
  tooltip: _propTypes2['default'].shape({
    headerShow: _propTypes2['default'].bool,
    show: _propTypes2['default'].bool,
    placement: _propTypes2['default'].oneOf(['left', 'right', 'top', 'bottom'])
  }),
  /**
   * 底部工具栏
   * @type {[type]}
   */
  bottomBars: _propTypes2['default'].element,
  /**
   * placeholder
   */
  placeholder: _propTypes2['default'].string
};

Select.defaultProps = {
  open: false,
  noSearchDataTips: '没有找到相关数据',
  hasIcon: false,
  selectAll: false,
  type: 'single',
  showMultipleSize: -1, // 不限
  maxHeight: 180,
  openSearch: false,
  showMultipleBar: true,
  maxSelectedSize: -1, // 不限
  placeholder: '',
  tooltip: {
    show: false,
    headerShow: false,
    placement: 'left'
  }
};

exports['default'] = Select;
module.exports = exports['default'];

// 获取 getDatas

// 获取选中的对象

// 获取选中的value 值

// 获取选中的文本内容